hdu 3342 Legal or Not 拓扑排序判断环

Problem Description

ACM-DIY is a large QQ group where many excellent acmers get together. It is so harmonious that just like a big family. Every day,many "holy cows" like HH, hh, AC, ZT, lcc, BF, Qinz and so on chat on-line to exchange their ideas. When someone has questions, many warm-hearted cows like Lost will come to help. Then the one being helped will call Lost "master", and Lost will have a nice "prentice". By and by, there are many pairs of "master and prentice". But then problem occurs: there are too many masters and too many prentices, how can we know whether it is legal or not?

We all know a master can have many prentices and a prentice may have a lot of masters too, it‘s legal. Nevertheless,some cows are not so honest, they hold illegal relationship. Take HH and 3xian for instant, HH is 3xian‘s master and, at the same time, 3xian is HH‘s master,which is quite illegal! To avoid this,please help us to judge whether their relationship is legal or not. 

Please note that the "master and prentice" relation is transitive. It means that if A is B‘s master ans B is C‘s master, then A is C‘s master.

Input

The input consists of several test cases. For each case, the first line contains two integers, N (members to be tested) and M (relationships to be tested)(2 <= N, M <= 100). Then M lines follow, each contains a pair of (x, y) which means x is y‘s master and y is x‘s prentice. The input is terminated by N = 0.
TO MAKE IT SIMPLE, we give every one a number (0, 1, 2,..., N-1). We use their numbers instead of their names.

Output

For each test case, print in one line the judgement of the messy relationship.
If it is legal, output "YES", otherwise "NO".

Sample Input

3 2 0 1 1 2 2 2 0 1 1 0 0 0

Sample Output

YES NO

题意:a是b的师傅,b是c的师傅,那么a是c的师傅,如果说c是a的师傅则不合法。先给出m个(x,y),即x是y的师傅,最后判断这种输入逻辑是否合法。一开始觉得这道题用并查集应该可以做,但是该题目点与点之间有明确的关系,不能只是有同一种性质那么简单。用拓扑排序来做,点之间相连形成了一个有向图,题目就是来判断这个有向图里面是否有环,如果有则不合法。方法是每次找入度为0的点,如果找到,入度减1,与之相连的点也相应-1,如果没找到,那么则说明有向图里面存在环。

没什么可讲的就是很基础的拓扑排序

AC代码:

#include<iostream>
#include<cstdio>
#include<cstring>
#define MAX 105
using namespace std;
int n,m;
int map[MAX][MAX],ind[MAX];
 
void topo()
{
	int i,j,x,y,k;
	memset(map,0,sizeof(map));
	memset(ind,0,sizeof(ind));
	int flag=1;
	for(i=1;i<=m;i++)
	{
		cin>>x>>y;
		if(!map[x][y])
		{
			map[x][y]=1;
			ind[y]++;
		}
	}
	for(i=0;i<n;i++)  //外层循环表示要循环n次,每次找出一个点 
	{
		for(j=0;j<n;j++) //内层循环表示每次找都要遍历完所有的点 
		{
			if(ind[j]==0)
			{
				ind[j]--;
				for(k=0;k<n;k++)
				{
				if(map[j][k])  ind[k]--; //删掉入度为0的这个点出发的所有边 	
				}
				break;	 //如果找到一个符合条件的点 就立即退出 
			}
			
		}
		if(j==n)//如果没有跳出就没有入度为0的点,即有环 
		{
			flag=0;
			break;
		}
	}
 if(flag) printf("YES\n");
 else printf("NO\n");

	
 		
}
int main()
{
	while(cin>>n>>m&&n)
	{
	
	topo();
}
	return 0;
 } 

猜你喜欢

转载自blog.csdn.net/zvenWang/article/details/81330592